/*
 * The Script for "Scene description language by XML" 1.0
 * (SLAX-Script 1.0)
 * The module for handling data (expansion and compression)
 * (for MSIE 5.5/6.0 , Firefox 1.x, Netscape 7(or later))
 * Copyright (C)2003-2005 Yutaka Furubayashi <info@yupotan.sppd.ne.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

// number -> compressed character

Number.prototype.compressNumber=function(n) {
 var a="",b=this;
 if (b>Math.pow(64,n)) return "";
 for (var i=n-1;i>-1;i--) {
  a+= String.fromCharCode(Math.floor(b/Math.pow(64,i))+63);
  b=b%Math.pow(64,i);
 }
 return a;
};

// 01001110...(array) -> compressed character

Array.prototype.compressFlag=function(){
 var a=this.length.compressNumber(2),b=this.join("")+"000000",c="";
 for (var i=0;i<Math.ceil(this.length/6);i++) {
  c+=parseInt(b.substring(i*6,i*6+6),2).compressNumber(1);
 }
 return a+c;
};

// compressed character -> number

String.prototype.expandNumber=function(){
 var a=0,b=this;
 for (var i=0;i<b.length;i++) {
  a+=((b.charAt(i).charCodeAt()-63)*(Math.pow(64,b.length-i-1)));
 }
 return a;
};

// compressed character -> 010000011...(array)

String.prototype.expandFlag=function(){
 var a=this,b=this.length,d="";
 var p=a.substring(0,2).expandNumber();
 var c=new Array(p);
 for (var i=2;i<b;i++) {
  d+=(64+a.charAt(i).expandNumber()).toString(2).substring(1,7);
 }
 for (var i=0;i<c.length;i++) {
  c[i]=parseInt(d.charAt(i),10);
 }
 return c;
}

// name -> compressed character

String.prototype.convertName=function(){
 var a=this.substring(0,7),b="";
 for (var i=0;i<7;i++) {
  b+=((a.charAt(i)) ? a.charAt(i).charCodeAt().compressNumber(3) : "???");
 }
 return b;
}

// compressed character -> name

String.prototype.getName=function(){
 var a=this,b="";
 for (var i=0;i<7;i++) {
  var c=a.substring(i*3,i*3+3);
  b+=((c=="???") ? "" : String.fromCharCode(c.expandNumber()));
 }
 return b;
}

// compressed data -> date

String.prototype.toDate=function(){
 var a=this,b;
 b=a.substring(0,2).expandNumber().toString();
 for (var i=2;i<4;i++){b+=("-"+(a.charAt(i).expandNumber()+100).toString().substring(1,3));}
 b+=(" "+(a.charAt(4).expandNumber()+100).toString().substring(1,3));
 for (var i=5;i<7;i++){b+=(":"+(a.charAt(i).expandNumber()+100).toString().substring(1,3));}
 return b;
}

// CG data -> compressed data

String.prototype.convertCG=function(){
 var a=this.split(".");
 var b=parseInt("1"+a[0],10).compressNumber(3);
 switch (a[1]) {
  case "png":
   b+="0"; break;
  case "jpg":
   b+="1"; break;
  case "gif":
   b+="2"; break;
  case "bmp":
   b+="3"; break;
  case "swf":
   b+="4"; break;
 }
 return b;
}

// compressed data -> CG data

String.prototype.getCG=function(){
 var a=this,b,c;
 b=a.substring(0,3).expandNumber().toString();
 b=b.substring(1,b.length);
 switch (a.charAt(3)) {
  case "0":
   b+=".png"; break;
  case "1":
   b+=".jpg"; break;
  case "2":
   b+=".gif"; break;
  case "3":
   b+=".bmp"; break;
  case "4":
   b+=".swf"; break;
 }
 return b;
}

// music data -> compressed data

String.prototype.convertM=function(){
 var _a=this,a,b;
 if (_a=="off") {
  a="0.mid".split(".");
  b=(parseInt("1"+a[0]),10).compressNumber(3);
 }
 else {
  a=_a.split(".");
  b=(parseInt("1"+a[0],10)+1).compressNumber(3);
 }
 switch (a[1]) {
  case "mid":
   b+="0"; break;
  case "mp3":
   b+="1"; break;
  case "wav":
   b+="2"; break;
  case "aiff":
   b+="3"; break;
  case "swf":
   b+="4"; break;
 }
 return b;
}

// compressed data -> music data

String.prototype.getM=function(){
 var a=this,b,c;
 b=a.substring(0,3).expandNumber().toString();
 b=b.substring(1,b.length);
 if (b=="0") return "off";
 b=(parseInt(b,10)-1).toString();
 switch (a.charAt(3)) {
  case "0":
   b+=".mid"; break;
  case "1":
   b+=".mp3"; break;
  case "2":
   b+=".wav"; break;
  case "3":
   b+=".aiff"; break;
  case "4":
   b+=".swf"; break;
 }
 return b;
}
